	  DOSSEG
	  .MODEL  small

_CODE  SEGMENT WORD PUBLIC 'CODE'	 ;Code segement
_CODE  ENDS
_DATA  SEGMENT WORD PUBLIC 'DATA'	 ;Data segement
_DATA  ENDS
STACK SEGMENT WORD PUBLIC 'STACK'	 ;Stack segement
STACK ENDS


DGROUP GROUP _CODE, _DATA, STACK

	   ASSUME CS:DGROUP,DS:DGROUP,SS:DGROUP,ES:DGROUP

;-----------------------------------------------------------------------;
; This file contains procedures for working with the disk i/o system	;
;									;
; GET_DRIVE			Get the current drive letter		;
; GET_DRIECTORY 		Get the current directory name		;
; GET_DISK_ERROR_CODE		Get the ASCII error text for the	;
;				hardware error				;
;									;
; GET_DOS_ERROR_CODE		Get the ASCII error test for the DOS	;
;				error					;
;									;
; SEPERATE_FILENAME		Seperates the filename from the pathname;
; ASSEMBLE_PATH 		Assembles the complete path name	;
; OPEN_FILE			Tries to open a file			;
; CREATE_FILE			Tries to create a file			;
; MOVE_FILE_POINTER		Moves the file pointer			;
; CLOSE_FILE			Closes an open file			;
; WRITE_FILE			Writes data to a file			;
; READ_FILE			Reads data from a file			;
; GET_PATH			Get the path				;
;-----------------------------------------------------------------------;

_DATA		SEGMENT PUBLIC
		PUBLIC	DRIVE_TABLE

DRIVE_TABLE		DB  "ABCDEFGHIJKLMNOPQRSTUVWXYZ"

ERROR_CODE_TABLE	LABEL	WORD
	DW	OFFSET DGROUP:ERROR_0
	DW	OFFSET DGROUP:ERROR_1
	DW	OFFSET DGROUP:ERROR_2
	DW	OFFSET DGROUP:ERROR_3
	DW	OFFSET DGROUP:ERROR_4
	DW	OFFSET DGROUP:ERROR_5
	DW	OFFSET DGROUP:ERROR_6
	DW	OFFSET DGROUP:ERROR_7
	DW	OFFSET DGROUP:ERROR_8
	DW	OFFSET DGROUP:ERROR_9
	DW	OFFSET DGROUP:ERROR_A
	DW	OFFSET DGROUP:ERROR_B
	DW	OFFSET DGROUP:ERROR_C
	DW	OFFSET DGROUP:ERROR_D
	DW	OFFSET DGROUP:ERROR_E
	DW	OFFSET DGROUP:ERROR_F


ERROR_0 	DB	'Write attempt on write-protected diskette','$'
ERROR_1 	DB	'Unknown unit','$'
ERROR_2 	DB	'Drive not ready','$'
ERROR_3 	DB	'Unknown command','$'
ERROR_4 	DB	'Data error (CRC)','$'
ERROR_5 	DB	'Bad request structure length','$'
ERROR_6 	DB	'Seek error','$'
ERROR_7 	DB	'Unknown media type','$'
ERROR_8 	DB	'Sector not found','$'
ERROR_9 	DB	'Printer out of paper','$'
ERROR_A 	DB	'Write fault','$'
ERROR_B 	DB	'Read fault','$'
ERROR_C 	DB	'General failure','$'
ERROR_D 	DB	'General failure','$'
ERROR_E 	DB	'Disk drive is invalid','$'
ERROR_F 	DB	'$'

DOS_ERROR_CODE_TABLE	    LABEL   WORD
	DW	OFFSET DGROUP:DOS_ERROR_0
	DW	OFFSET DGROUP:DOS_ERROR_1
	DW	OFFSET DGROUP:DOS_ERROR_2
	DW	OFFSET DGROUP:DOS_ERROR_3
	DW	OFFSET DGROUP:DOS_ERROR_4
	DW	OFFSET DGROUP:DOS_ERROR_5
	DW	OFFSET DGROUP:DOS_ERROR_6
	DW	OFFSET DGROUP:DOS_ERROR_7
	DW	OFFSET DGROUP:DOS_ERROR_8
	DW	OFFSET DGROUP:DOS_ERROR_9
	DW	OFFSET DGROUP:DOS_ERROR_A
	DW	OFFSET DGROUP:DOS_ERROR_B
	DW	OFFSET DGROUP:DOS_ERROR_C
	DW	OFFSET DGROUP:DOS_ERROR_D
	DW	OFFSET DGROUP:DOS_ERROR_E
	DW	OFFSET DGROUP:DOS_ERROR_F

DOS_ERROR_0	    DB	    "This file doesn't exists. Specify a new file.",'$'
DOS_ERROR_1	    DB	    'Function number invalid','$'
DOS_ERROR_2	    DB	    'File not found','$'
DOS_ERROR_3	    DB	    'Path invalid or not found','$'
DOS_ERROR_4	    DB	    'Too many open files','$'
DOS_ERROR_5	    DB	    'Access denied','$'
DOS_ERROR_6	    DB	    'Handle invalid','$'
DOS_ERROR_7	    DB	    'Memory control block destroyed','$'
DOS_ERROR_8	    DB	    'Insufficient memory','$'
DOS_ERROR_9	    DB	    'Memory block address invalid','$'
DOS_ERROR_A	    DB	    'Enviroment invalid','$'
DOS_ERROR_B	    DB	    'Format invalid','$'
DOS_ERROR_C	    DB	    'Access code invalid','$'
DOS_ERROR_D	    DB	    'Data invalid','$'
DOS_ERROR_E	    DB	    'Unknown unit','$'
DOS_ERROR_F	    DB	    'Disk drive invalid','$'

_DATA		ENDS


_CODE		SEGMENT PUBLIC

	PUBLIC	GET_DRIVE
;-----------------------------------------------------------------------;
; This procedure gets the current active disk drive.  This procedure	;
; is simular to DOS function 19H, except the ASCII drive letter is	;
; returned in AL.							;
;									;
; Returns:	AL	ASCII letter of current active drive		;
;-----------------------------------------------------------------------;
GET_DRIVE	PROC	FAR

	PUSH	DS
	MOV	AX,CS
	MOV	DS,AX
	MOV	AH,19h			;Call for get current disk
	INT	21h
	MOV	BX,OFFSET DRIVE_TABLE
	XLAT				;Get the drive letter from the table
	POP	DS
	RETF

GET_DRIVE	ENDP

	PUBLIC	GET_DIRECTORY
;-----------------------------------------------------------------------;
; This procedure gets the current active directory.			;
;									;
; Returns:	DS:DI	  ASCII name of current directory		;		;
;		AH	  the number of charcters in the name		;
;-----------------------------------------------------------------------;
GET_DIRECTORY	PROC	FAR

	PUSH	BX
	PUSH	CX
	PUSH	DX
	PUSH	ES
	PUSH	DI
	PUSH	SI
	MOV	AX,DS
	MOV	ES,AX
	MOV	AH,19h			;Call for get current disk
	INT	21h
	INC	AL
	MOV	DL,AL
	MOV	AH,47h			;Call for get current directory
	INT	21h
	SUB	AL,AL
	MOV	CX,65
	MOV	BX,CX
	MOV	DI,SI
	REPNE	SCASB
	SUB	BX,CX
	DEC	BX
	MOV	AX,BX
	POP	BX
	POP	CX
	POP	DX
	POP	ES
	POP	DI
	POP	SI
	RETF

GET_DIRECTORY	ENDP

	PUBLIC	GET_DISK_ERROR_CODE
;-----------------------------------------------------------------------;
; This procedure gets the error code from the disk error code table.	;
; BL is used as offset pointer in the disk error code table.		;
;									;
; Returns:	DS:BX	  Pointer to ASCII text of error code		;
;		CX	  the number of charcters in the name		;
;-----------------------------------------------------------------------;
GET_DISK_ERROR_CODE PROC    FAR

	PUSH	AX
	PUSH	DX
	MOV	AX,CS
	MOV	DS,AX
	XOR	BH,BH			;Convert to a word
	SHL	BX,1			;Multiply by 2 for word look-up
	MOV	DX,ERROR_CODE_TABLE[BX]   ;Get address of error message
	MOV	CX,ERROR_CODE_TABLE[BX+2] ;Get address of next error message
	SUB	CX,DX			;CX has number of characters in string.
	XCHG	BX,DX			;Save address in BX.
	POP	DX
	POP	AX
	RETF

GET_DISK_ERROR_CODE  ENDP

	PUBLIC	GET_DOS_ERROR_CODE
;-----------------------------------------------------------------------;
; This procedure gets the error code from the DOS error code table .	;
; BL is used as offset pointer in the disk error code table.		;
;									;
; Returns:	DS:BX	  Pointer to ASCII text of error code		;
;		CX	  the number of charcters in the name		;
;-----------------------------------------------------------------------;
GET_DOS_ERROR_CODE PROC FAR

	PUSH	AX
	PUSH	DX
	MOV	AX,CS
	MOV	DS,AX
	XOR	BH,BH			;Convert to a word
	SHL	BX,1			;Multiply by 2 for word look-up
	MOV	DX,DOS_ERROR_CODE_TABLE[BX]   ;Get address of error message
	MOV	CX,DOS_ERROR_CODE_TABLE[BX+2] ;Get address of next error message
	SUB	CX,DX			;CX has number of characters in string.
	XCHG	BX,DX			;Save address in BX.
	POP	DX
	POP	AX
	RETF

GET_DOS_ERROR_CODE ENDP

	PUBLIC	SEPERATE_FILENAME
;-----------------------------------------------------------------------;
; This procedure seperates the filename from the pathname. The pathname ;
; is pointed to by DS:SI.  The filesname is stored at the memory	;
; location pointed to by DS:DI.  The pathname has 00h appended to the	;
; end of the name.							;
;									;
; Returns:	Nothing 						;
;-----------------------------------------------------------------------;
SEPERATE_FILENAME  PROC  FAR

	PUSH AX
	PUSH CX
	PUSH ES
	MOV  AX,DS
	MOV  ES,AX
	PUSH SI 			;Save the location of the pathname.
	PUSH DI 			;Save the storage memory location.
	MOV DI,SI			;Set DI to point to the pathname
	INC DI
	MOV CL,[DI]			;Get the length of the string.
	SUB CH,CH
	PUSH CX 			;Save the length.
	INC DI
	ADD DI,CX			;Point DI to the end of the string.
	MOV AL,"\"                      ;Set AL to look for the backslash
	STD				;Set the directional flag to backwards.
	REPNZ SCASB
	XCHG CX,DX			;Save the remaining count in DX.
	POP CX				;Restore the length.
	SUB CX,DX			;Subtract the remaing count from the original length.
	XCHG DI,SI			;Put the pointer to the name in SI.
	CMP DX,0
	JE NO_SLASH
	SUB CX,2			;Adjust count.
	ADD DX,2			;Adjust count.
	ADD SI,2			;Point SI at the first character.
NO_SLASH:				;No backslash, don't adjust pointers or counters.
	POP DI				;Restore the storage memory location.
	PUSH SI 			;Save the pointer to the name.
	CLD				;Set the directional flag to forwards.
	REP MOVSB
	POP SI
	MOV BYTE PTR[DI],0		;Put a zero at the end of the filename.
	MOV BYTE PTR[SI-1],0		;Put a zero at the end of the pathname.
	POP SI				;Restore the location of the pathname.
	MOV BYTE PTR[SI+1],DL		;Save the new count of charcters in the pathname.
	POP ES
	POP CX
	POP AX
	RETF

SEPERATE_FILENAME ENDP

	PUBLIC	ASSEMBLE_PATH
;-----------------------------------------------------------------------;
; This procedure assembles the complet path name from the drive letter	;
; indentifier in BL and the path file name pointed to by DS:SI. 	;
; The results are stored at the memory location pointed to by DS:DI.	;
;									;
; Returns:	Nothing 						;
;-----------------------------------------------------------------------;
ASSEMBLE_PATH PROC    FAR

	PUSH AX
	PUSH CX
	PUSH ES
	MOV AX,DS
	MOV ES,AX			;Set ES to DS.
	MOV [DI],BL			;Store the drive letter.
	INC DI
	MOV BYTE PTR[DI],":"		;Store the colon.
	INC DI
	MOV BYTE PTR[DI],"\"            ;Store the first backslash.
	INC DI
	MOV CL,[SI+1]			;Get the length of the string.
	SUB CH,CH
	ADD SI,2
	CLD				;Set the directional flag to forwards.
	REP MOVSB
	POP ES
	POP CX
	POP AX
	RETF

ASSEMBLE_PATH  ENDP

	PUBLIC	OPEN_FILE
;-----------------------------------------------------------------------;
; This procedure tries to open the file pointed to by the DS:DX 	;
;									;
; Returns:	File handle in AX					;
;-----------------------------------------------------------------------;
OPEN_FILE PROC	  FAR

	MOV AH,3Dh			;DOS function code for open file.
	MOV AL,02h
	INT 21h 			;Call DOS.
	RETF

OPEN_FILE  ENDP

	PUBLIC	CREATE_FILE
;-----------------------------------------------------------------------;
; This procedure tries to create the file pointed to by the DS:DX	;
;									;
; Returns:	Nothing 						;
;-----------------------------------------------------------------------;
CREATE_FILE PROC    FAR

	PUSH CX
	MOV AH,3Ch			;DOS function code for creat file.
	SUB CX,CX			;Set normal file attribute.
	INT 21h 			;Call DOS.
	POP CX
	RETF

CREATE_FILE  ENDP


	PUBLIC	MOVE_FILE_POINTER
;-----------------------------------------------------------------------;
; This procedure moves the file pointer of a open file in the forward.	;
;  Handle is in BX.							;
;									;
; CX = MSB of offset, DX = LSB of offset,				;
; AL = 00h absolute offset from start of file				;
;    = 01H signed offset from current file pointer			;
;    = 02H signed offset from end of file				;
;									;
; Returns:	DX = MSB of offset, AX = LSB of offset			;			      ;
;-----------------------------------------------------------------------;
MOVE_FILE_POINTER PROC FAR

	MOV AH,42h			;DOS function code for move file pointer.
	INT 21h 			;Call DOS.
	RETF

MOVE_FILE_POINTER ENDP

	PUBLIC	CLOSE_FILE
;-----------------------------------------------------------------------;
; This procedure closes file assigned to the handle in BX		;
;									;
; Returns:	Nothing 						;
;-----------------------------------------------------------------------;
CLOSE_FILE PROC   FAR

	OR BX,BX
	JZ HANDLE_INVALID		;Make sure the handle isn't zero.
	MOV AH,3Eh			;DOS function code for close file.
	INT 21h 			;Call DOS.
HANDLE_INVALID:
	RETF

CLOSE_FILE  ENDP

	PUBLIC	WRITE_FILE
;-----------------------------------------------------------------------;
; This procedure write data to file. The handle is in BX. CX has the	;
; amount of bytes to write. DS:DX points to the data buffer.		;
;									;
; Returns:	AX = bytes written					;
;-----------------------------------------------------------------------;
WRITE_FILE PROC   FAR

	MOV AH,40h			;DOS function code for write data to file.
	INT 21h 			;Call DOS.
	RETF

WRITE_FILE  ENDP


	PUBLIC	READ_FILE
;-----------------------------------------------------------------------;
; This procedure reads data from a file. The handle is in BX.		;
; CX has the amount of bytes to read. DS:DX pointe to the data buffer.	;	   ;
;									;
; Returns:	AX = bytes read 					;
;-----------------------------------------------------------------------;
READ_FILE PROC	 FAR

	MOV AH,3Fh			;DOS function code for write data to file.
	INT 21h 			;Call DOS.
	RETF

READ_FILE  ENDP


	PUBLIC	GET_PATH
;-----------------------------------------------------------------------;
; This procedure appends a file name to a pathname extracted from	;
; specified SET statement in the eviroment (if it exists). If no SET	;
; statement exists the fileaname is appended to the to current Drive	;
; and path.								;
; Input     DI = pointer to filename, SI = pointer to pathname. 	;
;	    BX = first two characters of SET stringname.		;
;	    DX = second two characters of SET stringname.		;
;	    CX has enviroment segment address.				;
;									;
; Output    Pathname pointed to by SI will have pathname with filename	;
;	    appended to end.						;
;-----------------------------------------------------------------------;
GET_PATH	PROC  FAR

		PUSH DI 		;DI = pointer to filename.
		PUSH SI 		;SI = pointer to pathname.
		MOV AX,CS
		MOV DS,AX
		MOV ES,AX
		CMP CX,0
		JNZ GET_PATH_INFO
		JMP GET_PATH_END

GET_PATH_INFO:	MOV AX,CX		;Get enviroment segment address.
		MOV ES,AX		;Point ES to enviroment segment address.
		CLD			;Set to look forward.			  ;Set to look forward. 		    ;Set to look forward.
		SUB DI,DI		;Zero DI to point to top of segment.
		SUB AL,AL		;Zero AL.
		MOV CX,32768		;Load CX with max. enviroment size.
SCAN_FOR_END:	REPNZ  SCASB		;Look for a zero.
		CMP BYTE PTR ES:[DI],0	;Check for another zero after first zero.
		JNE SCAN_FOR_END	;If not a zero continue looking for end of enviroment.

		MOV CX,DI		;Load CX with number of bytes to end of enviroment.
		SUB DI,DI		;Zero DI to point to top of segment.
SCAN_FIRST:	MOV AX,BX		;Load AX with first two characters of SET = name.
		REPNZ SCASB		;Check for first character.
		JCXZ LOCAL_PATH
		CMP BYTE PTR ES:[DI],AH ;Check for second character.
		JNE SCAN_FIRST
		INC DI			;Increment pointer.
		DEC CX			;Deincrement counter.
		JZ LOCAL_PATH
		MOV AX,DX		;Load AX with second two characters of SET = name.
		CMP BYTE PTR ES:[DI],AL ;Check for third character.
		JNE SCAN_FIRST
		INC DI			;Increment pointer.
		DEC CX			;Deincrement counter.
		JZ LOCAL_PATH
		CMP BYTE PTR ES:[DI],AH ;Check for "fourth character.
		JNE SCAN_FIRST
		INC DI			;Increment pointer.
		DEC CX			;Deincrement counter.
		JZ LOCAL_PATH
		CMP BYTE PTR ES:[DI],"=";Check for "=" .
		JNE SCAN_FIRST
		INC DI			;Increment pointer.
		DEC CX			;Deincrement counter.
		JZ LOCAL_PATH
		PUSH DI 		;Save pointer to begining of string.
		SUB AL,AL		;Zero AL.
		REPNZ SCASB		;Look for a zero terminating the string.
		POP CX			;Get back pointer to begining of string.
		SUB DI,CX		;Subtract pointer to begining of string from pointer to end of string.
		XCHG DI,CX		;DI points to begining of string. CX has number of bytes to move.
		XCHG DI,SI		;SI points to begining of string. DI points to enternal data area.
		MOV AX,ES
		MOV DS,AX
		MOV AX,CS
		MOV ES,AX
		REP MOVSB		;Move path name from enviroment into my data space.
		MOV AX,CS
		MOV DS,AX
		MOV ES,AX
		DEC DI
		MOV BYTE PTR [DI],"\"   ;Put slash at end of path name.
		INC DI
		POP SI
		XCHG DI,SI
		JMP PARSE_FILE

LOCAL_PATH:	MOV AX,CS
		MOV DS,AX
		MOV ES,AX
		MOV AH,19H
		INT 21H 		;Get current drive.
		ADD AL,41H		;Add ascii A to AL.
		MOV BYTE PTR [SI],AL	;Put path in buffer
		ADD SI,3
		SUB DL,DL		;DL = default drive.
		MOV AH,47H
		INT 21H 		;Get current path.
		POP SI
		ADD SI,2		;Point SI to byte before path.
LOCAL_PATH_END: INC SI
		CMP BYTE PTR [SI],0	;Find end of pathname.
		JNE LOCAL_PATH_END
		MOV BYTE PTR [SI],"\"   ;Put slash at end of path name.
		INC SI			;Point SI to character after \.
		JMP PARSE_FILE

GET_PATH_END:	CLD			;Set to look forward.			  ;Set to look forward.
		POP DI			;Point DI to begining of path.
		MOV AL,"."		;Load AL with period.
		MOV CX,78		;Load CX with max. path size.
		REPNZ  SCASB		;Look for a period.
		STD			;Set to look backward.
		MOV CX,78		;Load CX with max. filename size.
		MOV AL,"\"              ;Load AL with \.
		REPNZ SCASB
		ADD DI,2		;Point DI to character after \.
		XCHG DI,SI		;Exchange SI/DI for PARSE FILE.

PARSE_FILE:	POP DI
		CLD			;Set to look forward.			  ;Set to look forward. 		    ;Set to look forward.
		XCHG SI,DI		;Exchange SI/DI.
		MOV CX,000CH		;Counter to 12
		REP MOVSB		;Move filename to end of pathname.
		MOV BYTE PTR [DI],0
		RETF

GET_PATH	ENDP

_CODE	ENDS

	END
