.286
	   DOSSEG
	  .MODEL  small


	   INCLUDELIB IDATA			;Tell linker to user IDATA library


Nul			 EQU   00H		;Ascii Nul control character.
Bel			 EQU   07H		;Ascii Bell control character.
TAB			 EQU   09		;Ascii Tab character.
LF			 EQU   0AH		;Ascii Line Feed control character.
CR			 EQU   0DH		;Ascii Carriage Return control character.
FF			 EQU   0CH		;Ascii Form Feed control character.
CRLF			 EQU   0A0DH		;Ascii Line Feed & Carriage Return control characters.
TABS			 EQU   0909H		;Ascii Tab characters.
Spaces			 EQU   2020H		;Ascii Space characters.
Space			 EQU   20H		;Ascii Space character.
Stop			 EQU   "$"		;Ascii dollar sign character.
BaseTen 		 EQU   10		;Base ten.
BIOSdataSegement	 EQU   0040H		;The BIOS data segment.
BIOSHardDrives		 EQU   0075H		;The location in BIOS data segment where the # of hard drives is stored.
Drive0StatusCMDRegister  EQU   01F7H		;Address of status and command register for drive 0.
Drive0DataRegister	 EQU   01F0H		;Address of data read/write register for drive 0.
Drive1StatusCMDRegister  EQU   0177H		;Address of status and command register for drive 1.
Drive1DataRegister	 EQU   0170H		;Address of data read/write register for drive 1.
IdentifyDeivceCMD	 EQU   0ECH		;ATA identify device command.
NoPortAtAddress 	 EQU   0FFH		;The byte returned if there isn't a valid port at the address read.
BufferSize		 EQU   256		;The size of the read buffer.
CylinderOffset		 EQU   1*2		;Offset to the no. of cylinders in the indentify drive read data.
CylinderBytes		 EQU   5		;The # of possible bytes in the no. of cylinders.
PIOorginalModeoffset	 EQU   51*2		;Offset to the PIO original (ATA) modes in the indentify drive read data.
PIOadvancedModeOffset	 EQU   64*2		;Offset to the PIO advanced (ATA-2) modes in the indentify drive read data.
HeadOffset		 EQU   3*2		;Offset to the no. of heads in the indentify drive read data.
HeadBytes		 EQU   5		;The # of possible bytes in the no. of heads.
LBADMAsupportOffset	 EQU   49*2		;Offset to the LBA DMA support in the indentify drive read data.
SectorOffset		 EQU   6*2		;Offset to the no. of sectors in the indentify drive read data.
SectorBytes		 EQU   5		;The # of possible bytes in the no. of sectors.
DMAmodesOffset		 EQU   52*2		;Offset to the DMA modes (ATA) support in the indentify drive read data.
DMAsingleOffset 	 EQU   62*2		;Offset to the DMA single (ATA-2) modes support in the indentify drive read data.
DMAmultiOffset		 EQU   63*2		;Offset to the DMA multi (ATA-2) modes support in the indentify drive read data.
SectorBufferOffset	 EQU   21*2		;Offset to the Sector buffer in the indentify drive read data.
SectorBufferBytes	 EQU   5		;The # of possible bytes in the sector buffer.
PerInterruptOffset	 EQU   47*2		;Offset to the sectors per interrupt in the indentify drive read data.
PerInterruptBytes	 EQU   3		;The # of possible bytes in sectors per interrupt.
SectorCapacityOffset	 EQU   57*2		;Offset to the capacity in sectors in the indentify drive read data.
SectorCapacityBytes	 EQU   10		;The # of possible capacity in sectors.
ModelNumberOffset	 EQU   27*2		;Offset to the model # in the indentify drive read data.
ModelNumberBytes	 EQU   2*(46-27)+2	;The # of bytes in the model #.
SerialNumberOffset	 EQU   10*2		;Offset to the serial # in the indentify drive read data.
SerialNumberBytes	 EQU   2*(19-10)+2	;The # of bytes in the serial #.
FirmwareOffset		 EQU   23*2		;Offset to the firmware string in the indentify drive read data.
FirmwareBytes		 EQU   2*(26-23)+2	;The # of bytes in the firware string.
SectorSize		 EQU   512		;The number of bytes in a sector.
ByteCapacityBytes	 EQU   14		;The # of possible capacity in bytes.

;Begin MACRO definitions -------------------------------------------------------

Recovery MACRO
                JMP $+2
		JMP $+2
		JMP $+2
		JMP $+2
         ENDM

;End MACRO definitions ---------------------------------------------------------

;Begin data definitions in other modules ---------------------------------------

;	    None

;End data definitions in other modules -----------------------------------------
;
;Begin code definitions in other modules ---------------------------------------

	    extrn Move_Cursor:FAR,Clear_Screen:FAR
	    extrn Read_Char:FAR,Open_File:FAR,Move_File_Pointer:FAR
	    extrn Read_File:FAR,Write_File:FAR,Close_File:FAR
	    extrn Hex_To_ASCII_Hex:FAR,Asc16:FAR,Convert_All:FAR

;End code definitions in other modules -----------------------------------------

_CODE  SEGMENT WORD PUBLIC 'CODE'	 ;Code segement
_CODE  ENDS

_DATA  SEGMENT WORD PUBLIC 'DATA'	 ;Data segement
_DATA  ENDS

STACK SEGMENT WORD PUBLIC 'STACK'	 ;Stack segement
STACK ENDS


DGROUP GROUP _CODE, _DATA, STACK

	   ASSUME CS:DGROUP,DS:DGROUP,SS:DGROUP,ES:DGROUP

_DATA	   SEGMENT
;Begin data definitions -------------------------------------------------------
;
;Begin local data --------------------------------------------------------------
Dssave			       dw SEG DGROUP
EnviromentSave		       dw ?			  ;The envirment segment.
PSPsave 		       dw ?

     ;............. Messages .....................
;********** Opening display message ********
TitleMessage		       LABEL PTR
ProgramName		       db "IDentify ATA, "
ProgramVersion		       db "v1.0 ",CR,LF
Copyright		       db "A public domain Freeware program."
			       db CR,LF,CR,LF,Stop

;********** Help display message ***********
HelpMessage		       LABEL PTR
			       db "Valid Commands: /2 = Display secondary port information",CR,LF
			       db "                /A = Display both primary and secondary port information"
			       db CR,LF,CR,LF,Stop

;********** Header message *****************
HeaderMessage		       LABEL PTR
			       db "**************************** PORT "
CurrentPort		       db ?
			       db " *** DRIVE "
CurrentDrive		       db ?
			       db " ****************************"
			       db CR,LF,Stop

;********** Main display message ***********
Cylinders		       db CylinderBytes        DUP (space)
			       db " Cylinders",TAB,TAB,TAB,TAB
			       db "PIO Mode(s): "
PIOmodes		       db 17		       DUP (space)
PIOmodesEND		       LABEL PTR
			       db CR,LF,Stop
Heads			       db HeadBytes	       DUP (space)
			       db " Heads",TAB,TAB,TAB,TAB
LBAandDMAmodes		       db 28		       DUP (space)
LBAandDMAmodesEND	       LABEL PTR
			       db CR,LF,Stop
Sectors 		       db SectorBytes	       DUP (space)
			       db " Sectors/Track",TAB,TAB,TAB
			       db "DMA Mode(s): "
DMAmodes		       db 19		       DUP (space)
DMAmodesEND		       LABEL PTR
			       db CR,LF,Stop
SectorBuffer		       db SectorBufferBytes    DUP (space)
			       db " KB Buffer Size,",TAB
PerInterrupt		       db PerInterruptBytes    DUP (space)
			       db " Sectors/Interrupt,",TAB
SectorCapacity		       db SectorCapacityBytes	 DUP (space)
			       db " User sectors"
SectorCapacityEND	       LABEL PTR
			       db CR,LF,Stop
ByteCapacity		       db ByteCapacityBytes    DUP (space)
			       db " User bytes"
ByteCapacityEND 	       LABEL PTR
			       db CR,LF,CR,LF,Stop
ModelMessage		       db "Model Number: "
ModelNumber		       db ModelNumberBytes+3   DUP (?)
ModelNumberEND		       LABEL PTR
SerialMessage		       db "Serial Number: "
SerialNumber		       db SerialNumberBytes+3  DUP (?)
SerialNumberEND 	       LABEL PTR
FirmwareMessage 	       db "Firmware: "
Firmware		       db FirmwareBytes+3      DUP (?)
FirmwareEND		       LABEL PTR
			       db CR,LF,Stop

;********** Error messages *****************
NoHardDrivesInstalled	       db CR,LF,"No hard drives are attached to this system!"
			       db CR,LF,Stop
NoIDEdrive		       db CR,LF,"No ATA DRIVE "
NoIDEdriveNumber	       db  ?
			       db  " available at PORT "
NoIDEportNumber 	       db  ?
			       db  CR,LF,Stop
NoModelNumber		       db  "No model number"
NoModelNumberEND	       LABEL PTR
NoSerialNumber		       db  "No serial number"
NoSerialNumberEND	       LABEL PTR
NoFirmware		       db  "None"
NoFirmwareEND		       LABEL PTR

     ;............. Other data ...................
ExitNow 		       db ?		  ;Exit now switch, used in displaying help.
BothDrives		       db ?		  ;Both drives switch 0 = drive 0, 1 = drive 1.
DoBothPorts		       db ?		  ;Do both ports switch, if 1 do both ports.
ATAString		       db "(ATA)"
ATAStringEND		       LABEL PTR
ATA2String		       db "(ATA-2)"
ATA2StringEND		       LABEL PTR
LBAandDMAstring 	       db "LBA & DMA modes supported"
LBAandDMAstringEND	       LABEL PTR
LBAstring		       db "LBA modes supported"
LBAstringEND		       LABEL PTR
DMAstring		       db "DMA modes supported"
DMAstringEND		       LABEL PTR
NeitherString		       db "Neither LBA or DMA supported"
NeitherStringEND	       LABEL PTR
Blanks			       db 28		       DUP (space)
CylHold 		       dw ?		  ;Cylinder data hold use to calculate numer of sectors on disk.
SecHold 		       dw ?		  ;Sector data hold use to calculate numer of sectors on disk.
HdHold			       dw ?		  ;Head data hold use to calculate numer of sectors on disk.
CapacityInSectors	       dd ?		  ;The number of sectors on the disk (used to calculate the number of bytes on the disk.
CapacityInBytes 	       dd ?		  ;The number of bytes on the disk.

     ;............. Drive Information ............
QuanityOfHardDrives	       db ?
PortToQuerry		       db ?
DriveToQuerry		       db ?
DeviceMask		       db 0		  ;Mask for device selection, if bit 4 = 0 device 0, if bit 4 = 1 device 1.
StatusCMDRegister	       dw (01f7h)	  ;Address of the status and command register of port we are talking to.
DeviceHeadRegister	       dw (01f6h)	  ;Address of the Device/Head register of the port we are talking to.
DataRegister		       dw (01f0h)	  ;Address of the data register of port we are talking to.
ReadBuffer		       dw BufferSize DUP (?)

;End local data ----------------------------------------------------------------
;
;End data definitions ----------------------------------------------------------
_DATA	   ENDS

_CODE	  SEGMENT
;Start of Main procedure -------------------------------------------------------

Main	  PROC	 FAR

	  MOV AX,@DATA			 ;Initialize data segment.
	  MOV BX,002CH
	  MOV BX,WORD PTR[BX]		 ;Get the enviroment segment.
	  MOV DS,AX
	  MOV [EnviromentSave],BX	 ;Save it.
	  MOV AX,ES			 ;Get PSP.
	  MOV WORD PTR PSPsave,AX	 ;Save PSP.
	  MOV AX,DS			 ;Get DS.
	  MOV ES,AX			 ;Make ES same as DS.
	  MOV BP,SP			 ;Save the initial SP.

;............. Do start up screen-ask ........................................
	  XOR DX,DX			 ;Zero Dx.
	  CALL Move_Cursor		 ;Move cursor to top of screen.
	  CALL Clear_Screen		 ;Clear screen.
	  MOV DX,OFFSET TitleMessage	 ;Get Title message.
	  CALL DisplayText		 ;Display Title message.

;............. Check command line for commands ...............................
	  CALL CommandLine		 ;Check command line for commands.
	  CMP [ExitNow],1		 ;Check exit now.
	  JNE CheckBIOS
	  JMP NormalEndofTask

;............. Check BIOS for presents of Hard Drives .........................
CheckBIOS:
	  PUSH ES				  ;Save ES.
	  MOV AX,BIOSdataSegement
	  MOV ES,AX				  ;Point ES to BIOS data segment.
	  XOR AL,AL				  ;Zero AL.
	  CMP AL,ES:[BIOSHardDrives]		  ;Get the quanity of hard drives reported by BIOS.
	  JE NoHardDrives
	  MOV AL,ES:[BIOSHardDrives]		  ;Get the quanity of hard drives reported by BIOS.
	  MOV [QuanityOfHardDrives],AL		  ;Save the quanity of hard drives reported by BIOS for later use.
	  POP ES				  ;Restore ES.
	  JMP short DrivesFound
     ;............. No drives found ........................
NoHardDrives:
	  MOV SP,BP				  ;Restore initial SP.
	  MOV DX,OFFSET NoHardDrivesInstalled	  ;Get no hard drives message.
	  CALL DisplayText			  ;Display no hard drives message.
	  JMP NormalEndofTask

     ;............. Drives found ...........................
DrivesFound:
	  MOV CX,3
	  CALL SelectDevice			  ;Select the device to talk to.

IsDriveAlive:
	  CALL GetDriveStatusByte		  ;Get the status byte for the current drive.
	  CMP AL,NoPortAtAddress		  ;See if there is a drive at this port.
	  JE NoDevice
	  AND AL,40H				  ;Zero bits 7,5 and 4.
	  TEST AL,40H				  ;Is drive ready?
	  JNZ IdentifyDevice
	  LOOP IsDriveAlive

     ;............. No IDE drive at this port ..............
NoDevice:
	  MOV SP,BP				  ;Restore initial SP.
	  MOV AL,DriveToQuerry			  ;Get the drive we tried to talk to in AL.
	  CALL HEX_TO_ASCII_HEX 		  ;Convert the drive number into its ASCII representation.
	  MOV [NoIDEdriveNumber],AH		  ;Put the ASCII representation in the display message.
	  MOV AL,PortToQuerry			  ;Get the port we tried to talk to in AL.
	  CALL HEX_TO_ASCII_HEX 		  ;Convert the port number into its ASCII representation.
	  MOV [NoIDEportNumber],AH		  ;Put the ASCII representation in the display message.
	  MOV DX,OFFSET NoIDEdrive		  ;Get no IDE drive message.
	  CALL DisplayText			  ;Display no IDE drive message.
	  JMP CheckBothDrives

     ;............. Identify the IDE drive ................
IdentifyDevice:
	  MOV AL,IdentifyDeivceCMD		  ;Put the identify device command in AL.
	  CALL SendCommand			  ;Send the command.
	  XOR CX,CX				  ;Zero CX.
CheckDRQ:
	  CALL GetDriveStatusByte		  ;Get the status byte for the current drive.
	  AND AL,0FH				  ;Zero bits 7 thru 4.
	  SHR AL,3				  ;Shift bit 3 to bit 1 position.
	  TEST AL,1				  ;Is drive ready to send data?
	  JNZ  DataIsReady
	  LOOP CheckDRQ

     ;............. Get the identify device data ..........
DataIsReady:
	  CALL ReadIdentifyDeviceData

;............. Build the main display message .................................

     ;............. Set up the Cylinders data .............
	  MOV SI,OFFSET ReadBuffer+CylinderOffset	   ;Put the offset to cylinder from read buffer in SI.
	  MOV DI,OFFSET Cylinders+CylinderBytes-1	   ;Put the offset to (cylinder+cylinder-1) bytes in DI.
	  Mov AX,[SI]
	  Mov [CylHold],AX				   ;Save the number of cylinders.
	  CALL Asc16
     ;............. Set up the PIO data ...................
	  CALL GetPIOmodes

     ;............. Set up the Heads data .................
	  MOV SI,OFFSET ReadBuffer+HeadOffset		   ;Put the offset to heads from read buffer in SI.
	  MOV DI,OFFSET Heads+HeadBytes-1		   ;Put the offset to (heads+head-1) bytes in DI.
	  Mov AX,[SI]
	  Mov [HdHold],AX				   ;Save the number of heads.
	  CALL Asc16

     ;............. Set up the LBA DMA data ................
	  CALL GetLBAandDMAmodes

     ;............. Set up the Sectors data ...............
	  MOV SI,OFFSET ReadBuffer+SectorOffset 	   ;Put the offset to sectors from read buffer in SI.
	  MOV DI,OFFSET Sectors+SectorBytes-1		   ;Put the offset to (sectors+sector-1) bytes in DI.
	  Mov AX,[SI]
	  Mov [SecHold],AX				   ;Save the number of sectors.
	  CALL Asc16

     ;............. Set up the DMA mode data ..............
	  CALL GetDMAmodes

     ;............. Set up the Sector Buffer size .........
	  MOV SI,OFFSET ReadBuffer+SectorBufferOffset	   ;Put the offset to sectors from read buffer in SI.
	  MOV AX,[SI]					   ;Get the word pointed to by SI into AX.
	  SHR AX,1					   ;Half the value by shifting AX right 1.
	  MOV [SI],AX					   ;Put the word back into the location pointed to by SI.
	  MOV DI,OFFSET SectorBuffer+SectorBufferBytes-1   ;Put the offset to (buffersize+buffersize-1) bytes in DI.
	  CALL Asc16

     ;............. Set up the Sector per interrupt ......
	  MOV SI,OFFSET ReadBuffer+PerInterruptOffset	   ;Put the offset to sectors per interrupt from read buffer in SI.
	  MOV DI,OFFSET PerInterrupt+PerInterruptBytes-1   ;Put the offset to (interruptsize+interruptsize-1) bytes in DI.
	  CALL Asc16

     ;............. Set up the Sector on disk ...........
	  SUB DX,DX					   ;Zero DX.
	  MOV AX,[SecHold]				   ;Get the number of sectors.
	  MOV BX,[HdHold]				   ;Get the number of heads.
	  MUL BX					   ;Sectors x heads.
	  MOV BX,[CylHold]				   ;Get the number of cylinders.
	  MUL BX					   ;Result of (sectors x heads) x cylinder
	  MOV SI,OFFSET CapacityInSectors		   ;Put the offset to capacity in sectors in SI.
	  MOV [SI],AX					   ;Store the LSW of capacity in sectors.
	  MOV [SI+2],DX 				   ;Store the MSW of capacity in sectors.
	  MOV BX,OFFSET SectorCapacity+SectorCapacityBytes-1   ;Put the offset to (sectorscapacitysize+sectorscapacity-1) bytes in BX.
	  MOV DI,OFFSET SectorCapacity			   ;Put the offset to sectors capacity in DI.
	  MOV SI,BaseTen				   ;Put base ten in SI.
	  CALL Convert_All

     ;............. Set up the capacity in bytes .........
	  CALL CalculateBytesOnDisk
	  MOV DI,OFFSET CapacityInBytes 		   ;Put the offset to capacity in bytes in DI.
	  MOV AX,[DI]					   ;Get the LSW of capacity in bytes into AX.
	  MOV DX,[DI+2] 				   ;Get the MSW of capacity in bytes into DX.
	  MOV BX,OFFSET ByteCapacity+ByteCapacityBytes-1   ;Put the offset to (bytecapacitysize+bytecapacity-1) bytes in BX.
	  MOV DI,OFFSET ByteCapacity			   ;Put the offset to byte capacity in DI.
	  MOV SI,BaseTen				   ;Put base ten in SI.
	  CALL Convert_All

     ;............. Set up the model number data ..........
	  MOV SI,OFFSET ReadBuffer+ModelNumberOffset	   ;Put the offset to model # from read buffer in SI.
	  MOV DI,OFFSET ModelNumber			   ;Put the offset to model # in DI.
	  MOV BX,OFFSET NoModelNumber			   ;Put the offset to model # message in BX.
	  MOV CX,ModelNumberBytes			   ;Put the # of bytes to examine/move in CX.
	  MOV DX,WORD PTR NoModelNumberEND-NoModelNumber   ;Put the # of bytes in model # message DX.
	  MOV AX,CRLF					   ;Put a CRLF in AX.
	  CALL ExamineDataMoveData

     ;............. Set up the serial number data .........
	  MOV SI,OFFSET ReadBuffer+SerialNumberOffset	   ;Put the offset to serial # from read buffer in SI.
	  MOV DI,OFFSET SerialNumber			   ;Put the offset to serial # in DI.
	  MOV BX,OFFSET NoSerialNumber			   ;Put the offset to serial # message in BX.
	  MOV CX,SerialNumberBytes			   ;Put the # of bytes to examine/move in CX.
	  MOV DX,WORD PTR NoSerialNumberEND-NoSerialNumber ;Put the # of bytes in serial # message DX.
	  MOV AX,CRLF					   ;Put TABS in AX.
	  CALL ExamineDataMoveData

     ;............. Set up the firmware data ..............
	  MOV SI,OFFSET ReadBuffer+FirmwareOffset	   ;Put the offset to firmware string from read buffer in SI.
	  MOV DI,OFFSET Firmware			   ;Put the offset to firmware string in DI.
	  MOV BX,OFFSET NoFirmware			   ;Put the offset to no serial # message in BX.
	  MOV CX,FirmwareBytes				   ;Put the # of bytes to examine/move in CX.
	  MOV DX,WORD PTR NoFirmwareEND-NoFirmware	   ;Put the # of bytes in firmware string message DX.
	  MOV AX,Spaces 				   ;Put a spaces in AX.
	  CALL ExamineDataMoveData

     ;............. Set up header message .................
	  MOV AL,PortToQuerry				   ;Get the port we tried to talk to in AL.
	  CALL HEX_TO_ASCII_HEX 			   ;Convert the port number into its ASCII representation.
	  MOV [CurrentPort],AH				   ;Put the ASCII representation in the display message.
	  MOV AL,DriveToQuerry				   ;Get the drive we tried to talk to in AL.
	  CALL HEX_TO_ASCII_HEX 			   ;Convert the drive number into its ASCII representation.
	  MOV [CurrentDrive],AH 			   ;Put the ASCII representation in the display message.

;............. Display messages ...............................................
	  MOV DX,OFFSET HeaderMessage
	  CALL DisplayText
	  MOV DX,OFFSET Cylinders
	  CALL DisplayText
	  MOV DX,OFFSET Heads
	  CALL DisplayText
	  MOV DX,OFFSET Sectors
	  CALL DisplayText
	  MOV DX,OFFSET SectorBuffer
	  CALL DisplayText
	  MOV DX,OFFSET ByteCapacity
	  CALL DisplayText
	  MOV DX,OFFSET ModelMessage
	  CALL DisplayText
	  MOV DX,OFFSET SerialMessage
	  CALL DisplayText
	  MOV DX,OFFSET FirmwareMessage
	  CALL DisplayText

;............. Check if we need to do both ports ..............................
CheckBothDrives:
	  CMP [BothDrives],1				   ;Check to see if we have done both drives.
	  JE CheckBothPorts
	  MOV [BothDrives],1				   ;Set both drives switch.
	  MOV [DriveToQuerry],1
	  MOV [DeviceMask],00010000b			   ;Set device mask to device 1.
	  CALL ClearFields
	  JMP DrivesFound

CheckBothPorts:
	  CMP [DoBothPorts],1				   ;Check to see if we need to do both ports.
	  JNE NormalEndofTask
	  MOV [DoBothPorts],0				   ;Re-set do both ports switch.
	  MOV [PortToQuerry],1
	  MOV [BothDrives],0				   ;Re-Set both drives switch.
	  MOV [DriveToQuerry],0
	  MOV [DeviceMask],0				   ;Set device mask to device 0.
	  MOV [StatusCMDRegister],0177H 		   ;Move the address of secondary port into the status and command register variable.
	  MOV [DeviceHeadRegister],0176H		   ;Move the address of second port into the device/head register variable.
	  MOV [DataRegister],0170H			   ;Move the address of second port into the data register variable.
	  CALL ClearFields
	  JMP DrivesFound

;...................... Program end area  .....................................
NormalEndofTask:
	  MOV AX,4C00H					   ;Request DOS to terminate program.
	  INT 21H					   ;Call DOS.

Main	  ENDP

;End of Main procedure ---------------------------------------------------------

;Begin text display procedure ---------------------------------------------------

DisplayText    PROC

	  MOV AH,09H					   ;Request DOS display text pointed to by DS:DX
	  INT 21H
	  RET


DisplayText   ENDP

;End text display procedure -----------------------------------------------------

;Begin calculate bytes on disk -------------------------------------------------

CalculateBytesOnDisk PROC

	  MOV BX,SectorSize
	  MOV SI,OFFSET CapacityInSectors		   ;Put the offset to capacity in sectors in SI.
	  MOV DI,OFFSET CapacityInBytes 		   ;Put the offset to capacity in bytes in DI.
	  MOV AX,[SI]					   ;Get the LSW of capacity in sectors.
	  MUL BX					   ;Multiply number of sectors by bytes in sector.
	  MOV [DI],AX					   ;Store LSW of result.
	  MOV [DI+2],DX 				   ;Store MSW of result.
	  MOV AX,[SI+2] 				   ;Get the MSW of capacity in sectors.
	  MUL BX
	  MOV BX,[DI+2] 				   ;Get the stored MSW results.
	  ADC BX,AX
	  JC ThereWasCarry
	  MOV [DI+2],BX
	  JMP CalculateBytesDone

ThereWasCarry:
	   INC BX
	   MOV [DI+2],BX

CalculateBytesDone:
	   RET

CalculateBytesOnDisk ENDP

;End calculate bytes on disk ---------------------------------------------------

;Begin select device  ----------------------------------------------------------

SelectDevice PROC

	  MOV DX,DeviceHeadRegister			   ;Put the device/head register address in DX.
	  IN AL,DX
	  Recovery
	  MOV AL,[DeviceMask]				   ;Mask the read data with device select mask.
	  OUT DX,AL
	  Recovery
	  RET

SelectDevice ENDP

;End select device  ----------------------------------------------------------

;Begin get drive status byte  ---------------------------------------------------

GetDriveStatusByte PROC

	  MOV DX,StatusCMDRegister			   ;Put the status/Command register address in DX.
	  IN AL,DX
	  Recovery
	  RET

GetDriveStatusByte ENDP

;End get drive status byte  ----------------------------------------------------

;Begin send command  -----------------------------------------------------------

SendCommand PROC

	  MOV DX,StatusCMDRegister			   ;Put the status/Command register address in DX.
	  OUT DX,AL
	  Recovery
	  RET

SendCommand ENDP

;End send command  -------------------------------------------------------------

;Begin indentify device data  --------------------------------------------------

ReadIdentifyDeviceData PROC

	  CLD					  ;Set direction flag forward.
	  MOV DI,OFFSET ReadBuffer		  ;Put offset to read buffer in DI.
	  MOV DX,DataRegister			  ;Put the data register address in DX.
	  MOV CX,BufferSize			  ;Put the size of read buffer in CX.
	  REP INSW
	  RET

ReadIdentifyDeviceData ENDP

;End indentify device data  ----------------------------------------------------

;Begin examine and move data  --------------------------------------------------

ExamineDataMoveData  PROC

	  PUSH AX				  ;Put AX message termination bytes on stack until later.
	  XOR AX,AX				  ;Zero AX.
	  CMP AX,[SI]				  ;If first word = 000h no data in field.
	  JZ FieldEmpty
	  PUSH DI				  ;Put DI value on stack until later.
	  PUSH SI				  ;Put SI value on stack.
	  POP DI				  ;Put pushed SI value in DI.
	  MOV AL,Space				  ;Put a space in AL.
	  CLD					  ;Set direction flag forward (low to high).
	  REPZ SCASB				  ;Find the first non-space character.
	  DEC DI				  ;Deincrement DI for correct postion,
	  PUSH DI				  ;Save the pointer to the begining of the string.
	  ADD DI,CX				  ;Add CX to DI so it points to end of string.
	  STD					  ;Set direction flag backward (high to low).
	  REPZ SCASB				  ;Find the first none space character.
	  POP SI				  ;Put pushed DI value in SI.
	  ADD CX,2				  ;Add 2 to CX for correct count.
	  POP DI				  ;Restore DI pointer.
	  XOR BX,BX				  ;Zero BX.
MoveBytes:
	  MOV AX,[SI+BX]			  ;Get word from read buffer.
	  XCHG AH,AL				  ;Swap the bytes that drive sent to us in reverse order.
	  MOV [DI+BX],AX			  ;Store the word in the message.
	  ADD BX,2				  ;Adjust BX by 2 to point to next word.
	  DEC CX				  ;Deincrement CX for correct count.
	  LOOP MoveBytes
	  POP AX				  ;Restore the message termination bytes.
	  MOV [DI+BX],AX			  ;Store the a message termination bytes at the end of message.
	  CMP AX,CRLF				  ;Does AX have a CRLF?
	  JNE NoStop
	  MOV BYTE PTR[DI+BX+2],STOP		  ;Store the STOP at the end of message.
NoStop:
	  RET

FieldEmpty:
	  PUSH BX				  ;Put BX value on stack.
	  POP SI				  ;Put pushed BX value in SI.
	  PUSH DX				  ;Put DX value on stack.
	  POP CX				  ;Put pushed DX value in CX.
	  REP MOVSB
	  POP AX				  ;Restore the message termination bytes.
	  MOV [DI+1],AX 			  ;Store the a message termination bytes at the end of message.
	  CMP AX,CRLF				  ;Does AX have a CRLF?
	  JNE NoStop
	  MOV BYTE PTR[DI+3],STOP		  ;Store the STOP at the end of message.
	  RET

ExamineDataMoveData  ENDP

;End examine and move data  ----------------------------------------------------

;Begin get PIO modes -----------------------------------------------------------

GetPIOmodes	   PROC

	  MOV DI,OFFSET PIOmodes			   ;Put the offset to PIO string in DI.
	  MOV SI,OFFSET ReadBuffer+PIOorginalModeoffset    ;Put the offset to PIO orginal modes from read buffer in SI.
	  MOV AX,[SI]					   ;Get the PIO orginal (ATA) modes word.
	  CMP AH,2					   ;If AH is 2 modes 0 1 2 are supported and advanced modes are possible supported.
	  JNE ModeTwoNotSupported
	  MOV [DI],"0"					   ;Put a 0 in PIO mode string.
	  INC DI
	  MOV [DI],Space				   ;Put a space in PIO mode string.
	  INC DI
	  MOV [DI],"1"					   ;Put a 1 in PIO mode string.
	  INC DI
	  MOV [DI],Space				   ;Put a space in PIO mode string.
	  INC DI
	  MOV [DI],"2"					   ;Put a 2 in PIO mode string.
	  INC DI
	  MOV [DI],Space				   ;Put a space in PIO mode string.
	  INC DI
	  JMP TestAdvancedPIOmodes
ModeTwoNotSupported:
	  CMP AH,1					   ;If AH is 1 modes 0 1 are supported but no advanced modes.
	  JNE ModeOneNotSupported
	  MOV [DI],"0"					   ;Put a 0 in PIO mode string.
	  INC DI
	  MOV [DI],Space				   ;Put a space in PIO mode string.
	  INC DI
	  MOV [DI],"1"					   ;Put a 1 in PIO mode string.
	  INC DI
	  MOV [DI],Space				   ;Put a space in PIO mode string.
	  INC DI
	  JMP TestAdvancedPIOmodes

ModeOneNotSupported:
	  MOV [DI],"0"					   ;Put a 0 in PIO mode string.
	  INC DI
	  MOV [DI],Space				   ;Put a space in PIO mode string.
	  INC DI
	  JMP TestAdvancedPIOmodes

ItsATA:   MOV SI, OFFSET ATAString			   ;Put the offset to ATA string in SI.
	  MOV CX,ATAStringEND-ATAString 		   ;Put the # of bytes to move in CX.
	  REP MOVSB
	  JMP GetPIOmodesDone

TestAdvancedPIOmodes:
	  MOV SI,OFFSET ReadBuffer+PIOadvancedModeOffset   ;Put the offset to PIO advanced modes from read buffer in SI.
	  MOV AX,[SI]					   ;Get the PIO advanced (ATA-2) modes word.
	  CMP AL,0					   ;If AL is 0 no advanced modes are supported.
	  JE ItsATA
	  MOV [DI],"3"					   ;Put a 3 in PIO mode string.
	  INC DI
	  MOV [DI],Space				   ;Put a space in PIO mode string.
	  INC DI
	  CMP AL,3					   ;If AL is less then 3 mode 4 isn't supported.
	  JL ModeFourNotSupported
	  MOV [DI],"4"					   ;Put a 4 in PIO mode string.
	  INC DI
	  MOV [DI],Space				   ;Put a space in PIO mode string.
	  INC DI
ModeFourNotSupported:
	  MOV SI, OFFSET ATA2String			    ;Put the offset to ATA string in SI.
	  MOV CX,ATA2StringEND-ATA2String		    ;Put the # of bytes to move in CX.
	  REP MOVSB
GetPIOmodesDone:
	  RET

GetPIOmodes	   ENDP

;End get PIO modes -------------------------------------------------------------

;Begin get LBA and DMA modes ---------------------------------------------------

GetLBAandDMAmodes  PROC

	  MOV DI,OFFSET LBAandDMAmodes			   ;Put the offset to LBA and DMA string in DI.
	  MOV SI,OFFSET ReadBuffer+LBADMAsupportOffset	   ;Put the offset to LBA, DMA from read buffer in SI.
	  MOV AX,[SI]					   ;Get the LBA, DMA support word.
	  AND AH,03H					   ;Zero bits 7 thru 2.
	  CMP AH,3					   ;If AH 3 both LBA, DMA supported.
	  JE LBAandDMA
	  TEST AH,2					   ;If AH bit 1 set LBA only supported.
	  JNZ LBAonly
	  TEST AH,1					   ;If AH bit 0 set DMA only supported.
	  JNZ DMAonly
	  JMP NeitherLBAorDMA
LBAandDMA:
	  MOV SI,OFFSET LBAandDMAstring 		  ;Put the offset to LBA and DMA string in SI.
	  MOV CX,LBAandDMAstringEND-LBAandDMAstring	   ;Put the # of bytes to move in CX.
	  REP MOVSB
	  JMP GetLBAandDMAmodeDone
LBAonly:
	  MOV SI,OFFSET LBAstring			  ;Put the offset to LBA string in SI.
	  MOV CX,LBAstringEND-LBAstring 		   ;Put the # of bytes to move in CX.
	  REP MOVSB
	  JMP GetLBAandDMAmodeDone
DMAonly:
	  MOV SI,OFFSET DMAstring			  ;Put the offset to DMA string in SI.
	  MOV CX,DMAstringEND-DMAstring 		   ;Put the # of bytes to move in CX.
	  REP MOVSB
	  JMP GetLBAandDMAmodeDone
NeitherLBAorDMA:
	  MOV SI,OFFSET NeitherString			  ;Put the offset to neither LBA or DMA string in SI.
	  MOV CX,NeitherStringEND-NeitherString 	   ;Put the # of bytes to move in CX.
	  REP MOVSB
	  JMP GetLBAandDMAmodeDone

GetLBAandDMAmodeDone:
	  RET

GetLBAandDMAmodes  ENDP

;End get LBA and DMA modes -----------------------------------------------------


;Start DMA modes ---------------------------------------------------------------

GetDMAmodes	   PROC

	  MOV DI,OFFSET DMAmodes			   ;Put the offset to DMA modes string in DI.
	  PUSH DI					   ;Save DI offset until later.
	  MOV SI,OFFSET ReadBuffer+DMAsingleOffset	   ;Put the offset to DMA single modes from read buffer in SI.
	  MOV AX,[SI]					   ;Get the DMA single modes word.
	  AND AL,07H					   ;Zero bits 7 thru 3.
	  CMP AL,7					   ;If AH 7 DMA single modes 0,1,2 supported.
	  JE SingleModes012
	  CMP AL,3					   ;If AH 3 DMA single modes 0,1 supported.
	  JE SingleModes01
	  CMP AL,1					   ;If AH 1 DMA single mode 0 supported.
	  JE SingleModes0
	  JMP CheckDMAmulti
SingleModes012:
	  MOV [DI],"0s" 				   ;Put a s0 in DMO mode string.
	  INC DI
	  INC DI
	  MOV [DI],Space				   ;Put a space in DMA mode string.
	  INC DI
	  MOV [DI],"1s" 				   ;Put a s1 in DMO mode string.
	  INC DI
	  INC DI
	  MOV [DI],Space				   ;Put a space in DMA mode string.
	  INC DI
	  MOV [DI],"2s" 				   ;Put a s1 in DMO mode string.
	  INC DI
	  INC DI
	  MOV [DI],Space				   ;Put a space in DMA mode string.
	  INC DI
	  JMP CheckDMAmulti
SingleModes01:
	  MOV [DI],"0s" 				   ;Put a s0 in DMO mode string.
	  INC DI
	  INC DI
	  MOV [DI],Space				   ;Put a space in DMA mode string.
	  INC DI
	  MOV [DI],"1s" 				   ;Put a s1 in DMO mode string.
	  INC DI
	  INC DI
	  MOV [DI],Space				   ;Put a space in DMA mode string.
	  INC DI
	  JMP CheckDMAmulti
SingleModes0:
	  MOV [DI],"0s" 				   ;Put a s0 in DMO mode string.
	  INC DI
	  INC DI
	  MOV [DI],Space				   ;Put a space in DMA mode string.
	  INC DI
	  JMP CheckDMAmulti
CheckDMAmulti:
	  MOV SI,OFFSET ReadBuffer+DMAmultiOffset	   ;Put the offset to DMA multi modes from read buffer in SI.
	  MOV AX,[SI]					   ;Get the DMA multi modes word.
	  AND AL,07H					   ;Zero bits 7 thru 3.
	  CMP AL,7					   ;If AH 7 DMA multi modes 0,1,2 supported.
	  JE MultiModes012
	  CMP AL,3					   ;If AH 3 DMA multi modes 0,1 supported.
	  JE MultiModes01
	  CMP AL,1					   ;If AH 1 DMA multi mode 0 supported.
	  JE MultiModes0
	  JMP DMAata2ModesDone
MultiModes012:
	  MOV [DI],"0d" 				   ;Put a s0 in DMO mode string.
	  INC DI
	  INC DI
	  MOV [DI],Space				   ;Put a space in DMA mode string.
	  INC DI
	  MOV [DI],"1d" 				   ;Put a s1 in DMO mode string.
	  INC DI
	  INC DI
	  MOV [DI],Space				   ;Put a space in DMA mode string.
	  INC DI
	  MOV [DI],"2d" 				   ;Put a s1 in DMO mode string.
	  INC DI
	  INC DI
	  MOV [DI],Space				   ;Put a space in DMA mode string.
	  INC DI
	  JMP DMAata2ModesDone
MultiModes01:
	  MOV [DI],"0d" 				   ;Put a s0 in DMO mode string.
	  INC DI
	  INC DI
	  MOV [DI],Space				   ;Put a space in DMA mode string.
	  INC DI
	  MOV [DI],"1d" 				   ;Put a s1 in DMO mode string.
	  INC DI
	  INC DI
	  MOV [DI],Space				   ;Put a space in DMA mode string.
	  INC DI
	  JMP DMAata2ModesDone
MultiModes0:
	  MOV [DI],"0d" 				   ;Put a s0 in DMO mode string.
	  INC DI
	  INC DI
	  MOV [DI],Space				   ;Put a space in DMA mode string.
	  INC DI

DMAata2ModesDone:
	  POP SI					   ;Restore saved offset to SI.
	  CMP DI,SI					   ;If DI and SI equal there were no ATA-2 DMA modes found.
	  JNE NoATAmodes
	  MOV SI,OFFSET ReadBuffer+DMAmodesOffset	   ;Put the offset to DMA modes (ATA) from read buffer in SI.
	  MOV AX,[SI]					   ;Get the DMA modes (ATA) word.
	  AND AH,02H					   ;Zero bits 7 thru 2.
	  CMP AH,2					   ;If AH 2 DMA ATA modes 0,1,2 supported.
	  JE DMAmodes012
	  CMP AH,1					   ;If AH 1 DMA ATA modes 0,1 supported.
	  JE DMAmodes01
	  CMP AH,0					   ;If AH 0 DMA ATA mode 0 supported.
	  JE DMAmodes0
	  JMP NoATAmodes
DMAmodes012:
	  MOV [DI],"0"					   ;Put a 0 in DMO mode string.
	  INC DI
	  MOV [DI],Space				   ;Put a space in DMA mode string.
	  INC DI
	  MOV [DI],"1"					   ;Put a 1 in DMO mode string.
	  INC DI
	  MOV [DI],Space				   ;Put a space in DMA mode string.
	  INC DI
	  MOV [DI],"2"					   ;Put a 1 in DMO mode string.
	  INC DI
	  MOV [DI],Space				   ;Put a space in DMA mode string.
	  INC DI
	  JMP NoATAmodes
DMAmodes01:
	  MOV [DI],"0"					   ;Put a 0 in DMO mode string.
	  INC DI
	  MOV [DI],Space				   ;Put a space in DMA mode string.
	  INC DI
	  MOV [DI],"1"					   ;Put a 1 in DMO mode string.
	  INC DI
	  MOV [DI],Space				   ;Put a space in DMA mode string.
	  INC DI
	  JMP NoATAmodes
DMAmodes0:
	  MOV [DI],"0"					   ;Put a 0 in DMO mode string.
	  INC DI
	  MOV [DI],Space				   ;Put a space in DMA mode string.
	  INC DI

NoATAmodes:
	  RET

GetDMAmodes	   ENDP

;End DMA modes ---------------------------------------------------------------

;Begin process command line ----------------------------------------------------

CommandLine	PROC

		MOV AX,[PSPsave]			   ;Get the save PSP.
		PUSH DS 				   ;Save DS.
		MOV DS,AX				   ;Put PSP in DS.
		SUB AX,AX				   ;Zero AX.
		MOV SI,0080H				   ;Point to PSP command line buffer.
		MOV AL,BYTE PTR [SI]			   ;Get number of bytes in command line.
		MOV CX,AX				   ;Load CX with number of bytes in command line.
		CMP AX,0				   ;If AX = 0 there are no commands on command line.
		JNE FindForwardSlash
		POP DS					   ;Restore DS
		RET					   ;No commands on command line return.

FindForwardSlash:
		INC SI					   ;Point SI to first character in command line.
		CMP BYTE PTR [SI],"/"
		JE FoundForwardSlash
		LOOP FindForwardSlash
		POP DS					   ;Restore DS.
		RET					   ;Character on command is not one we're looking for. Just do drive 0.

FoundForwardSlash:
		MOV CX,AX				   ;Re-load CX with number of bytes in command line.
		MOV BX,SI				   ;Save SI pointer in BX.
FindTheTwo:	INC SI					   ;Point SI to next character in command line.
		CMP BYTE PTR [SI],"2"			   ;Look for a 2.
		JE FoundTheTwo
		LOOP FindTheTwo
		JMP FindAnA				   ;Didnt find a 2 go look for an A.
FoundTheTwo:	POP DS					   ;Restore DS.
		MOV [StatusCMDRegister],0177H		   ;Move the address of second drive (DRIVE 1) into the status and command register variable.
		MOV [DeviceHeadRegister],0176H		   ;Move the address of second port into the device/head register variable.
		MOV [DataRegister],0170H		   ;Move the address of second drive (DRIVE 1) into the data register varible.
		MOV [PortToQuerry],1
		RET

FindAnA:	MOV CX,AX				   ;Re-load CX with number of bytes in command line.
		MOV SI,BX				   ;Restore saved pointer to SI.
FindTheA:	INC SI
		CMP BYTE PTR [SI],"A"
		JE FoundTheA
		CMP BYTE PTR [SI],"a"
		JE FoundTheA
		LOOP FindTheA
		JMP DisplayHelp 			   ;Character on command is not one we're looking for. Display Help.

FoundTheA:	POP DS					   ;Restore DS.
		MOV [DoBothPorts],1			   ;Set do both ports switch.
		RET

DisplayHelp:	POP DS					   ;Restore DS.
		MOV [ExitNow],1 			   ;Set exit now.
		MOV DX,OFFSET HelpMessage		   ;Get Help message.
		CALL DisplayText			   ;Display Help message.
		RET

CommandLine	ENDP

;End process command line ------------------------------------------------------

;Begin clear fields ------------------------------------------------------------

ClearFields	PROC

	  CLD						   ;Set direction flag forward (low to high).
	  MOV CX,WORD PTR PIOmodesEND-PIOmodes		   ;Get the amount of bytes in PIO mode string.
	  MOV DI,OFFSET PIOmodes			   ;Put the offset to PIO mode string in DI.
	  MOV SI,OFFSET Blanks				   ;Put the offset to blank string in SI.
	  REP MOVSB
	  MOV CX,WORD PTR LBAandDMAmodesEND-LBAandDMAmodes ;Get the amount of bytes in DMA and PIO modes string.
	  MOV DI,OFFSET LBAandDMAmodes			   ;Put the offset to DMA and PIO modes string in DI.
	  MOV SI,OFFSET Blanks				   ;Put the offset to blank string in SI.
	  REP MOVSB
	  MOV CX,WORD PTR DMAmodesEND-DMAmodes		   ;Get the amount of bytes in DMA mode string.
	  MOV DI,OFFSET DMAmodes			   ;Put the offset to DMA mode string in DI.
	  MOV SI,OFFSET Blanks				   ;Put the offset to blank string in SI.
	  REP MOVSB
	  MOV CX,WORD PTR ModelNumberEND-ModelNumber	   ;Get the amount of bytes in model number string.
	  MOV DI,OFFSET ModelNumber			   ;Put the offset to model number string in DI.
	  MOV SI,OFFSET Blanks				   ;Put the offset to blank string in SI.
	  REP MOVSB
	  MOV CX,WORD PTR SerialNumberEND-SerialNumber	   ;Get the amount of bytes in serial number string.
	  MOV DI,OFFSET SerialNumber			   ;Put the offset to serial number string in DI.
	  MOV SI,OFFSET Blanks				   ;Put the offset to blank string in SI.
	  REP MOVSB
	  MOV CX,WORD PTR FirmwareEND-Firmware		   ;Get the amount of bytes in firware string.
	  MOV DI,OFFSET Firmware			   ;Put the offset to firware string in DI.
	  MOV SI,OFFSET Blanks				   ;Put the offset to blank string in SI.
	  REP MOVSB
	  RET

ClearFields	ENDP

;End clear fields --------------------------------------------------------------

;Begin display feedback message procedure --------------------------------------

FeedbackMessage    PROC

	  MOV CX,11			 ;Count of bytes to copy.
	  REP MOVSB
	  CALL DisplayText		 ;Display the message.
	  RET

FeedbackMessage    ENDP

;End display feedback message procedure ----------------------------------------

;
;
;
_DATA	  SEGMENT
;
; --------------- other data definitions ---------------------------------------
;
_DATA	  ENDS
_CODE	  ENDS

_CODE	   SEGMENT
;-------------------------------------------------------------------------------
_CODE	  ENDS
	  END  Main
